package org.skife.intercept;

import junit.framework.TestCase;
import org.skife.intercept.signatures.NamedSignature;
import com.mockobjects.dynamic.Mock;
import com.mockobjects.dynamic.AnyConstraintMatcher;

import java.util.Map;

public class FailingTests extends TestCase
{
    InterceptionBroker broker;

    public void setUp()
    {
        broker = new InterceptionBroker();
    }

    public void testNothing() { }

    public void _testHowToDoConnectionSpecificTransactions()
    {
        fail("Figure it out");
    }

    public void _testBakedInterception()
    {
        InterceptionBroker broker = new InterceptionBroker();
        MockInterceptor intercept = new MockInterceptor();
        broker.addInterceptor(intercept, new NamedSignature("put"));
        broker.bake();
        Mock mock = new Mock(Map.class);
        mock.expect("put", new AnyConstraintMatcher());
        Map wrap = null;
        try
        {
            wrap = (Map) broker.wrap(mock.proxy());
        }
        catch (UnsupportedOperationException e)
        {
            fail("Broker baking not implemented yet");
        }
        wrap.put("1", "2");
        assertTrue(intercept.value);
    }
}
