package org.skife.intercept;

import junit.framework.TestCase;

import java.lang.reflect.Method;

public class TestBaking extends TestCase
{
    public void testImmutabilityOfBakedBroker()
    {
        InterceptionBroker broker = new InterceptionBroker();

        broker.bake();
        try
        {
            broker.addInterceptor(new Interceptor()
            {
                public Object intercept(Object base, Method method, Object[] args, InterceptorStack stack) throws Throwable
                {
                    return null;
                }
            }, new Signature()
            {
                public boolean matches(Method m)
                {
                    return false;
                }
            });
            fail("Should have thrown UOE when adding interceptor to baked broker");
        }
        catch (UnsupportedOperationException e)
        {
            assertTrue(true);
        }
    }
}
