package org.skife.intercept.benchmark;

import org.codehaus.nanning.AspectInstance;
import org.codehaus.nanning.Mixin;
import org.codehaus.nanning.MethodInterceptor;
import org.codehaus.nanning.Invocation;

public class NanningInterceptionProvider implements InterceptionProvider
{
    public InterceptMe build(int count, InterceptMe base)
    {
        AspectInstance instance = new AspectInstance();
        Mixin mixin = new Mixin(InterceptMe.class, base);
        instance.addMixin(mixin);
        for (int i = 0; i < count; ++i)
        {
            try
            {
                mixin.addInterceptor(InterceptMe.class.getMethod("call", null), new MethodInterceptor()
                {
                    public Object invoke(Invocation invocation) throws Throwable
                    {
                        return invocation.invokeNext();
                    }
                });
            }
            catch (Exception e)
            {
                throw new Error(e);
            }
        }
        return (InterceptMe) instance.getProxy();
    }
}
