package org.skife.intercept.benchmark;

import org.skife.intercept.InterceptionBroker;
import org.skife.intercept.Interceptor;
import org.skife.intercept.InterceptorStack;
import org.skife.intercept.signatures.NamedSignature;

import java.lang.reflect.Method;

public class SkifeInterceptionProvider implements InterceptionProvider
{
    private long count = 0;
    public InterceptMe build(int count, InterceptMe base)
    {
        InterceptionBroker broker = new InterceptionBroker();
        for (int i = 0; i < count; ++i)
        {
            broker.addInterceptor(new Empty(), new NamedSignature("call"));
        }
        InterceptMe wrap = (InterceptMe) broker.wrap(base);
        return wrap;
    }

    public class Empty implements Interceptor
    {
        public Object intercept(Object base, Method method, Object[] args, InterceptorStack stack) throws Throwable
        {
            return stack.yield();
        }
    }
}
