package org.skife.intercept.benchmark;

import org.springframework.aop.framework.ProxyFactory;
import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;

public class SpringInterceptionProvider implements InterceptionProvider
{
    public InterceptMe build(int count, InterceptMe base)
    {
        ProxyFactory pc = new ProxyFactory(base);
        for (int i = 0; i < count; ++i)
        {
            pc.addInterceptor(new MethodInterceptor()
            {
                public Object invoke(MethodInvocation invocation) throws Throwable
                {
                    return invocation.proceed();
                }

            });
        }
        return (InterceptMe) pc.getProxy();
    }
}
