package org.skife.intercept.interceptors.security;

import junit.framework.TestCase;
import com.mockobjects.dynamic.Mock;
import com.mockobjects.dynamic.AnyConstraintMatcher;

public class TestSecurityBroker extends TestCase
{
    public void testAllow()
    {
        assertTrue(Rules.ALLOW.allow(null));
    }

    public void testDeny()
    {
        assertFalse(Rules.DENY.allow(null));
    }

    public void testRuleOrdering()
    {
        SecurityBroker broker = new SecurityBroker();
        Mock first = new Mock(Rule.class);
        Mock second = new Mock(Rule.class);
        first.expectAndReturn("allow", new AnyConstraintMatcher(), true);
        second.expectAndReturn("allow", new AnyConstraintMatcher(), false);

        broker.appendRule((Rule)second.proxy());
        broker.prependRule((Rule)first.proxy());

        broker.test(null, null, null);

        first.verify();
        second.verify();
    }
}
