package org.skife.mixin;

import junit.framework.TestCase;

import java.util.Map;
import java.util.HashMap;

import org.skife.intercept.InterceptionBroker;
import org.skife.intercept.MockInterceptor;
import org.skife.intercept.signatures.ClassSignature;

public class TestMixer extends TestCase
{
    public void testMixer()
    {
        Mixer mixer = new Mixer();
        mixer.addMixin(Map.class, new HashMap());
        Object base = new Object();
        Object mixed = mixer.mix(base);
        assertTrue(mixed instanceof Map);
    }

    public void testInterceptMixins()
    {
        InterceptionBroker broker = new InterceptionBroker();
        MockInterceptor mock = new MockInterceptor();
        broker.addInterceptor(mock, new ClassSignature(Map.class));

        Mixer mixer = new Mixer();
        mixer.addMixin(Map.class, new HashMap());
        Object base = new Object();
        Object mixed = mixer.mix(base);

        Map wrapped = (Map) broker.wrap(mixed);
        wrapped.put("1", "2");
        assertTrue(mock.value);
    }
}
